git-clone.shon commit Merge branch 'master' of git://git.kernel.org/pub/scm/gitk/gitk (fe5e7f3)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005, Linus Torvalds
   4# Copyright (c) 2005, Junio C Hamano
   5#
   6# Clone a repository into a different directory that does not yet exist.
   7
   8# See git-sh-setup why.
   9unset CDPATH
  10
  11die() {
  12        echo >&2 "$@"
  13        exit 1
  14}
  15
  16usage() {
  17        die "Usage: $0 [--template=<template_directory>] [--reference <reference-repo>] [--bare] [-l [-s]] [-q] [-u <upload-pack>] [--origin <name>] [--depth <n>] [-n] <repo> [<dir>]"
  18}
  19
  20get_repo_base() {
  21        (
  22                cd "`/bin/pwd`" &&
  23                cd "$1" || cd "$1.git" &&
  24                {
  25                        cd .git
  26                        pwd
  27                }
  28        ) 2>/dev/null
  29}
  30
  31if [ -n "$GIT_SSL_NO_VERIFY" ]; then
  32    curl_extra_args="-k"
  33fi
  34
  35http_fetch () {
  36        # $1 = Remote, $2 = Local
  37        curl -nsfL $curl_extra_args "$1" >"$2"
  38}
  39
  40clone_dumb_http () {
  41        # $1 - remote, $2 - local
  42        cd "$2" &&
  43        clone_tmp="$GIT_DIR/clone-tmp" &&
  44        mkdir -p "$clone_tmp" || exit 1
  45        if [ -n "$GIT_CURL_FTP_NO_EPSV" -o \
  46                "`git-config --bool http.noEPSV`" = true ]; then
  47                curl_extra_args="${curl_extra_args} --disable-epsv"
  48        fi
  49        http_fetch "$1/info/refs" "$clone_tmp/refs" ||
  50                die "Cannot get remote repository information.
  51Perhaps git-update-server-info needs to be run there?"
  52        test "z$quiet" = z && v=-v || v=
  53        while read sha1 refname
  54        do
  55                name=`expr "z$refname" : 'zrefs/\(.*\)'` &&
  56                case "$name" in
  57                *^*)    continue;;
  58                esac
  59                case "$bare,$name" in
  60                yes,* | ,heads/* | ,tags/*) ;;
  61                *)      continue ;;
  62                esac
  63                if test -n "$use_separate_remote" &&
  64                   branch_name=`expr "z$name" : 'zheads/\(.*\)'`
  65                then
  66                        tname="remotes/$origin/$branch_name"
  67                else
  68                        tname=$name
  69                fi
  70                git-http-fetch $v -a -w "$tname" "$sha1" "$1" || exit 1
  71        done <"$clone_tmp/refs"
  72        rm -fr "$clone_tmp"
  73        http_fetch "$1/HEAD" "$GIT_DIR/REMOTE_HEAD" ||
  74        rm -f "$GIT_DIR/REMOTE_HEAD"
  75}
  76
  77quiet=
  78local=no
  79use_local=no
  80local_shared=no
  81unset template
  82no_checkout=
  83upload_pack=
  84bare=
  85reference=
  86origin=
  87origin_override=
  88use_separate_remote=t
  89depth=
  90no_progress=
  91test -t 1 || no_progress=--no-progress
  92while
  93        case "$#,$1" in
  94        0,*) break ;;
  95        *,-n|*,--no|*,--no-|*,--no-c|*,--no-ch|*,--no-che|*,--no-chec|\
  96        *,--no-check|*,--no-checko|*,--no-checkou|*,--no-checkout)
  97          no_checkout=yes ;;
  98        *,--na|*,--nak|*,--nake|*,--naked|\
  99        *,-b|*,--b|*,--ba|*,--bar|*,--bare) bare=yes ;;
 100        *,-l|*,--l|*,--lo|*,--loc|*,--loca|*,--local) use_local=yes ;;
 101        *,-s|*,--s|*,--sh|*,--sha|*,--shar|*,--share|*,--shared)
 102          local_shared=yes; use_local=yes ;;
 103        1,--template) usage ;;
 104        *,--template)
 105                shift; template="--template=$1" ;;
 106        *,--template=*)
 107          template="$1" ;;
 108        *,-q|*,--quiet) quiet=-q ;;
 109        *,--use-separate-remote) ;;
 110        *,--no-separate-remote)
 111                die "clones are always made with separate-remote layout" ;;
 112        1,--reference) usage ;;
 113        *,--reference)
 114                shift; reference="$1" ;;
 115        *,--reference=*)
 116                reference=`expr "z$1" : 'z--reference=\(.*\)'` ;;
 117        *,-o|*,--or|*,--ori|*,--orig|*,--origi|*,--origin)
 118                case "$2" in
 119                '')
 120                    usage ;;
 121                */*)
 122                    die "'$2' is not suitable for an origin name"
 123                esac
 124                git-check-ref-format "heads/$2" ||
 125                    die "'$2' is not suitable for a branch name"
 126                test -z "$origin_override" ||
 127                    die "Do not give more than one --origin options."
 128                origin_override=yes
 129                origin="$2"; shift
 130                ;;
 131        1,-u|1,--upload-pack) usage ;;
 132        *,-u|*,--upload-pack)
 133                shift
 134                upload_pack="--upload-pack=$1" ;;
 135        *,--upload-pack=*)
 136                upload_pack=--upload-pack=$(expr "z$1" : 'z-[^=]*=\(.*\)') ;;
 137        1,--depth) usage;;
 138        *,--depth)
 139                shift
 140                depth="--depth=$1";;
 141        *,-*) usage ;;
 142        *) break ;;
 143        esac
 144do
 145        shift
 146done
 147
 148repo="$1"
 149test -n "$repo" ||
 150    die 'you must specify a repository to clone.'
 151
 152# --bare implies --no-checkout and --no-separate-remote
 153if test yes = "$bare"
 154then
 155        if test yes = "$origin_override"
 156        then
 157                die '--bare and --origin $origin options are incompatible.'
 158        fi
 159        no_checkout=yes
 160        use_separate_remote=
 161fi
 162
 163if test -z "$origin"
 164then
 165        origin=origin
 166fi
 167
 168# Turn the source into an absolute path if
 169# it is local
 170if base=$(get_repo_base "$repo"); then
 171        repo="$base"
 172        local=yes
 173fi
 174
 175dir="$2"
 176# Try using "humanish" part of source repo if user didn't specify one
 177[ -z "$dir" ] && dir=$(echo "$repo" | sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
 178[ -e "$dir" ] && die "destination directory '$dir' already exists."
 179mkdir -p "$dir" &&
 180D=$(cd "$dir" && pwd) &&
 181trap 'err=$?; cd ..; rm -rf "$D"; exit $err' 0
 182case "$bare" in
 183yes)
 184        GIT_DIR="$D" ;;
 185*)
 186        GIT_DIR="$D/.git" ;;
 187esac && export GIT_DIR && git-init ${template+"$template"} || usage
 188
 189if test -n "$reference"
 190then
 191        ref_git=
 192        if test -d "$reference"
 193        then
 194                if test -d "$reference/.git/objects"
 195                then
 196                        ref_git="$reference/.git"
 197                elif test -d "$reference/objects"
 198                then
 199                        ref_git="$reference"
 200                fi
 201        fi
 202        if test -n "$ref_git"
 203        then
 204                ref_git=$(cd "$ref_git" && pwd)
 205                echo "$ref_git/objects" >"$GIT_DIR/objects/info/alternates"
 206                (
 207                        GIT_DIR="$ref_git" git for-each-ref \
 208                                --format='%(objectname) %(*objectname)'
 209                ) |
 210                while read a b
 211                do
 212                        test -z "$a" ||
 213                        git update-ref "refs/reference-tmp/$a" "$a"
 214                        test -z "$b" ||
 215                        git update-ref "refs/reference-tmp/$b" "$b"
 216                done
 217        else
 218                die "reference repository '$reference' is not a local directory."
 219        fi
 220fi
 221
 222rm -f "$GIT_DIR/CLONE_HEAD"
 223
 224# We do local magic only when the user tells us to.
 225case "$local,$use_local" in
 226yes,yes)
 227        ( cd "$repo/objects" ) ||
 228                die "-l flag seen but repository '$repo' is not local."
 229
 230        case "$local_shared" in
 231        no)
 232            # See if we can hardlink and drop "l" if not.
 233            sample_file=$(cd "$repo" && \
 234                          find objects -type f -print | sed -e 1q)
 235
 236            # objects directory should not be empty since we are cloning!
 237            test -f "$repo/$sample_file" || exit
 238
 239            l=
 240            if ln "$repo/$sample_file" "$GIT_DIR/objects/sample" 2>/dev/null
 241            then
 242                    l=l
 243            fi &&
 244            rm -f "$GIT_DIR/objects/sample" &&
 245            cd "$repo" &&
 246            find objects -depth -print | cpio -pumd$l "$GIT_DIR/" || exit 1
 247            ;;
 248        yes)
 249            mkdir -p "$GIT_DIR/objects/info"
 250            echo "$repo/objects" >> "$GIT_DIR/objects/info/alternates"
 251            ;;
 252        esac
 253        git-ls-remote "$repo" >"$GIT_DIR/CLONE_HEAD" || exit 1
 254        ;;
 255*)
 256        case "$repo" in
 257        rsync://*)
 258                case "$depth" in
 259                "") ;;
 260                *) die "shallow over rsync not supported" ;;
 261                esac
 262                rsync $quiet -av --ignore-existing  \
 263                        --exclude info "$repo/objects/" "$GIT_DIR/objects/" ||
 264                exit
 265                # Look at objects/info/alternates for rsync -- http will
 266                # support it natively and git native ones will do it on the
 267                # remote end.  Not having that file is not a crime.
 268                rsync -q "$repo/objects/info/alternates" \
 269                        "$GIT_DIR/TMP_ALT" 2>/dev/null ||
 270                        rm -f "$GIT_DIR/TMP_ALT"
 271                if test -f "$GIT_DIR/TMP_ALT"
 272                then
 273                    ( cd "$D" &&
 274                      . git-parse-remote &&
 275                      resolve_alternates "$repo" <"$GIT_DIR/TMP_ALT" ) |
 276                    while read alt
 277                    do
 278                        case "$alt" in 'bad alternate: '*) die "$alt";; esac
 279                        case "$quiet" in
 280                        '')     echo >&2 "Getting alternate: $alt" ;;
 281                        esac
 282                        rsync $quiet -av --ignore-existing  \
 283                            --exclude info "$alt" "$GIT_DIR/objects" || exit
 284                    done
 285                    rm -f "$GIT_DIR/TMP_ALT"
 286                fi
 287                git-ls-remote "$repo" >"$GIT_DIR/CLONE_HEAD" || exit 1
 288                ;;
 289        https://*|http://*|ftp://*)
 290                case "$depth" in
 291                "") ;;
 292                *) die "shallow over http or ftp not supported" ;;
 293                esac
 294                if test -z "@@NO_CURL@@"
 295                then
 296                        clone_dumb_http "$repo" "$D"
 297                else
 298                        die "http transport not supported, rebuild Git with curl support"
 299                fi
 300                ;;
 301        *)
 302                case "$upload_pack" in
 303                '') git-fetch-pack --all -k $quiet $depth $no_progress "$repo";;
 304                *) git-fetch-pack --all -k $quiet "$upload_pack" $depth $no_progress "$repo" ;;
 305                esac >"$GIT_DIR/CLONE_HEAD" ||
 306                        die "fetch-pack from '$repo' failed."
 307                ;;
 308        esac
 309        ;;
 310esac
 311test -d "$GIT_DIR/refs/reference-tmp" && rm -fr "$GIT_DIR/refs/reference-tmp"
 312
 313if test -f "$GIT_DIR/CLONE_HEAD"
 314then
 315        # Read git-fetch-pack -k output and store the remote branches.
 316        if [ -n "$use_separate_remote" ]
 317        then
 318                branch_top="remotes/$origin"
 319        else
 320                branch_top="heads"
 321        fi
 322        tag_top="tags"
 323        while read sha1 name
 324        do
 325                case "$name" in
 326                *'^{}')
 327                        continue ;;
 328                HEAD)
 329                        destname="REMOTE_HEAD" ;;
 330                refs/heads/*)
 331                        destname="refs/$branch_top/${name#refs/heads/}" ;;
 332                refs/tags/*)
 333                        destname="refs/$tag_top/${name#refs/tags/}" ;;
 334                *)
 335                        continue ;;
 336                esac
 337                git-update-ref -m "clone: from $repo" "$destname" "$sha1" ""
 338        done < "$GIT_DIR/CLONE_HEAD"
 339fi
 340
 341cd "$D" || exit
 342
 343if test -z "$bare" && test -f "$GIT_DIR/REMOTE_HEAD"
 344then
 345        # a non-bare repository is always in separate-remote layout
 346        remote_top="refs/remotes/$origin"
 347        head_sha1=`cat "$GIT_DIR/REMOTE_HEAD"`
 348        case "$head_sha1" in
 349        'ref: refs/'*)
 350                # Uh-oh, the remote told us (http transport done against
 351                # new style repository with a symref HEAD).
 352                # Ideally we should skip the guesswork but for now
 353                # opt for minimum change.
 354                head_sha1=`expr "z$head_sha1" : 'zref: refs/heads/\(.*\)'`
 355                head_sha1=`cat "$GIT_DIR/$remote_top/$head_sha1"`
 356                ;;
 357        esac
 358
 359        # The name under $remote_top the remote HEAD seems to point at.
 360        head_points_at=$(
 361                (
 362                        test -f "$GIT_DIR/$remote_top/master" && echo "master"
 363                        cd "$GIT_DIR/$remote_top" &&
 364                        find . -type f -print | sed -e 's/^\.\///'
 365                ) | (
 366                done=f
 367                while read name
 368                do
 369                        test t = $done && continue
 370                        branch_tip=`cat "$GIT_DIR/$remote_top/$name"`
 371                        if test "$head_sha1" = "$branch_tip"
 372                        then
 373                                echo "$name"
 374                                done=t
 375                        fi
 376                done
 377                )
 378        )
 379
 380        # Upstream URL
 381        git-config remote."$origin".url "$repo" &&
 382
 383        # Set up the mappings to track the remote branches.
 384        git-config remote."$origin".fetch \
 385                "+refs/heads/*:$remote_top/*" '^$' &&
 386
 387        # Write out remote.$origin config, and update our "$head_points_at".
 388        case "$head_points_at" in
 389        ?*)
 390                # Local default branch
 391                git-symbolic-ref HEAD "refs/heads/$head_points_at" &&
 392
 393                # Tracking branch for the primary branch at the remote.
 394                git-update-ref HEAD "$head_sha1" &&
 395
 396                rm -f "refs/remotes/$origin/HEAD"
 397                git-symbolic-ref "refs/remotes/$origin/HEAD" \
 398                        "refs/remotes/$origin/$head_points_at" &&
 399
 400                git-config branch."$head_points_at".remote "$origin" &&
 401                git-config branch."$head_points_at".merge "refs/heads/$head_points_at"
 402                ;;
 403        '')
 404                # Source had detached HEAD pointing nowhere
 405                git-update-ref --no-deref HEAD "$head_sha1" &&
 406                rm -f "refs/remotes/$origin/HEAD"
 407                ;;
 408        esac
 409
 410        case "$no_checkout" in
 411        '')
 412                test "z$quiet" = z -a "z$no_progress" = z && v=-v || v=
 413                git-read-tree -m -u $v HEAD HEAD
 414        esac
 415fi
 416rm -f "$GIT_DIR/CLONE_HEAD" "$GIT_DIR/REMOTE_HEAD"
 417
 418trap - 0